
//
//	Xanthus
//	Copyright (c) 1992, 1993, Bjorn Backlund & Jesper Lundh.  
//	All rights reserved. 
//

///////////////////////////////////////////////////////////////////////////////
//
// Change Log
//
//
// Wed Dec 28 19:25:17 GMT+0100 1994
// Bjorn Backlund
// Added OOE_APPINFO_PASTEBOARDTYPE
//
//
// Mon Nov  7 19:18:00 GMT+0100 1994
// Bjorn Backlund
// Changed OOE_getSize: (out NXSize *) to 
// to OOE_getSize: (NXSize *) 
//
//
// Mon Nov  7 19:18:46 GMT+0100 1994
// Bjorn Backlund
// Added OAI_OOE_LAUNCH_TIMEOUT
//
//
///////////////////////////////////////////////////////////////////////////////

#import <appkit/appkit.h>

#define OOE_LAUNCH_DEFAULT		"OOE_Launch"
#define OOE_PASTEBOARD			"OOE Pasteboard"
#define OOE_BASELINE_PASTEBOARDTYPE	"OOE_Baseline"

//
// OOE 2.0
// Added 941228
//

#define OOE_APPINFO_PASTEBOARDTYPE	"OOE_ApplicationInfoPboardType"

#define OAI_OOE_APPLICATION		"OOE_Application"

//
//

#define OAI_OOE_VERSION			"OOE_Version"
#define OAI_OOE_SERVER			"OOE_Server"
#define OAI_OOE_PASTEBOARD		"OOE_PasteboardType"
#define OAI_OOE_BASELINE_SUPPORT	"OOE_BaselineSupport"
#define OAI_OOE_INTERFACE_PASTEBOARD	"OOE_InterfaceInfoPasteboardType"
#define OAI_OOE_IN_TIMEOUT		"OOE_InTimeout"
#define OAI_OOE_OUT_TIMEOUT		"OOE_OutTimeout"
#define OAI_OOE_LAUNCH_TIMEOUT		"OOE_LaunchTimeout"	// Added 941105


//
//

@protocol OOE_ServerInterface

	// Top level interface
	// Sent by Clients to Servers
	
	
- OOE_newDocument:client;

	// Create a new server document and connect to client
	// Return proxy to new document
	
- OOE_openDocument:client;

	// Create a new server document and connect to client
	// Init new document using data on pasteboard
	// Return proxy to new document
	
@end









@protocol OOE_DocumentInterface

	// Server Document Interface
	// Sent by Clients to Server Documents
	
	
- (int)OOE_connectToClient:client;

	// Store client within document
	
- (int)OOE_isDocEdited;

	// Return 1 if server document is edited
	// Return 0 otherwise
	
	
- (int)OOE_orderDocumentFront:(in id)sender;

	// Bring the main editor window to front
	// Return 1 is window brought front,
	// 0 otherwise
	
- (oneway void)OOE_closeDocument:(in id)sender;

	// Close Server Document
	
	
- (int)OOE_sizeTo:(NXCoord in)width:(NXCoord in)height;

	// Change size of server document
	//
	// The size should be the size of the image to 
	// be displayed, which doesn't have to
	// be the size of the editing area. 
	// For example, in Xanthus Questor, the editing area
	// is the whole worksheet but only parts of 
	// it is sent back as an image
	//
	// Return 1 if size changed,
	// 0 otherwise
	
	 
- (int)OOE_getSize:(NXSize *)aSize;
	
	// Return in aSize the size of the main editor window
	// See note on size above.
	
- (int)OOE_provideData:(in id)sender;
	
	// Omit document, display and optional baseline and interface
	// data to the OOE pasteboard
	
	
- (int)OOE_document: client savedAs:(const char *)path;

	// Tells server that client document has been saved
	// Server can decide to update its window title according
	// to the new path
	
	
@end





@protocol OOE_ClientInterface

	// Client Interface, messages sent from Server Documents to
	// Clients


- (const char *)OOE_documentPath:sender;

	// Return path of client document


- (int)OOE_orderClientDocumentFront:(in id)sender;

	// Bring main client window to front
	
	
- (int)OOE_documentWillClose:(in id)document;

	// Tell client that server document will be closed


- (int) OOE_documentWasChanged:(in id)document;

	// Tell client that server document is dirty

@end




@protocol OOE_Admin	// Optional protocol

			// Can be implemented by both
			// servers and server documents

- (int)OOE_inTimeout;

	// Specifies in milliseconds the 'in'-timeout 
	// the client should use. 
	// See (NXConnection: setInTimeout:)

- (int)OOE_outTimeout;

	// Specifies in milliseconds the 
	// 'out'-timeout the client should use	
	// See (NXConnection: setOutTimeout:)


@end
