
#import <appkit/appkit.h>

@interface WoodApp: Application
{
	BOOL	haveOpenedDocument;			// Have we opened a document yet?
    id 		plpAccessory;				// accessory view of page layout panel
	id		pageMargin;					// augmented PageLayout object					
	id		inspectorManager;
	id 		docList;
	char	defaultDir[MAXPATHLEN+1];	// the default directory
	BOOL	saveAll;					// save all upon closing
	BOOL	dumpAll;					// ignore dirty bits upon closing
	id		addMenu;
	id		bundleList;
	id      infoController;
}

+ initialize;
- setDocClass:newDoc;
- docClass;
- inspectorManager;
- loadLocalNib:(const char *)nibName owner:aOwner;
- openFile:(const char *)path file:(const char *)type flag:(BOOL)flag;
- currentDocument;
- (const char *)currentDirectory;
- (const char *)docExtension;
- setDefaultDir:(const char *)dir;
- (BOOL)saveAll;
- setSaveAll:(BOOL)value;
- (BOOL)dumpAll;
- setDumpAll:(BOOL)value;
- pageLayout:sender;
- (NXZone *)newDocZone;
- reuseDocZone:(NXZone *)aZone;
- new:sender;
- open:sender;
- saveAll:sender;
- print:sender;
- samples:sender;
- (BOOL)menuItemUpdate:menuCell;
- (BOOL)validateCommand:menuCell;
- setupPageLayout:(float)lm :(float)rm :(float)tm :(float)bm; 
- app:sender willShowHelpPanel:panel;
- appWillInit:sender;
- appDidInit:sender;
- appWillTerminate:sender;
- (int)appOpenFile:(const char *)path type:(const char *)type;
- (BOOL)appAcceptsAnotherFile:sender;
- (int)app:sender unmounting:(const char *)fullPath;
- (int)msgDirectory:(const char **)fullPath ok:(int *)flag;
- (int)msgFile:(const char **)fullPath ok:(int *)flag;
- (int)msgPrint:(const char *)fullPath ok:(int *)flag;
- (int)msgVersion:(const char **)aString ok:(int *)flag;
- (int)msgQuit:(int *)flag;
- registerDoc:aDoc;
- freeDoc:aDoc;
- docList;
- createBundlesAndLoadModules:(BOOL)doLoad;
- loadFilter:sender;
- createBundlesForDirectory:(const char *)dirPath loadModules:(BOOL)doLoad;
- filter:(int)nr;
- app:sender willShowHelpPanel:panel;

@end
