
#import "wooddoc.h"

#define OOE_SERVER_NAME	"Wood_OOE_Server"

@implementation WoodApp (OOE)

- registerAsOOEServer;
{
	id aConnection;
	
	aConnection = [NXConnection registerRoot: self
				withName: OOE_SERVER_NAME];
	//[aConnection registerForInvalidationNotification:self];			
	[aConnection runFromAppKit];	 	
	return self;
}

- senderIsInvalid:sender;
{
    return self;
}

- OOE_newDocument:client;
{
	id doc;
	
	doc = [[[self docClass] allocFromZone:[self newDocZone]] initNewOOE:client];
	return doc;
}

- OOE_openDocument:client;
{
	id doc;

	doc = [[[self docClass] allocFromZone:[self newDocZone]] initOOE:client];
	[[doc window] display];
	return doc;
}

- reportOOEProblem: (const char *)title
	format: (const char * ) format, ...;
{
	va_list a; 
	char alert[2048];

	va_start(a, format);
	vsprintf(alert, format, a);
	va_end(a);
	NXRunAlertPanel(title, alert, "OK", NULL, NULL);
	return self;
}

@end


