
#import <appkit/Responder.h>

#import "Tree.h"

extern Window *createWindowFor(View *view, NXRect *windowContentRect, const char *frameString);

@interface WoodDoc : Object 
{ 
    id 		window;				// the window the View is in 
    id 		printInfo;			// Print Margins etc. 
    char 	*name;				// the name of the document 
    char 	*directory;			// the directory it is in 
    BOOL 	haveSavedDocument;	// whether document has associated disk file 
	BOOL	dirty;				// Whether or not the document needs saving 
	BOOL	empty;				// is the document empty? 
	int     tag;				// a unique tag across the application
	BOOL	textViewSaved;
	id doubleView;
	id textView;
	id treeView;
	id scrollView;
	id tree;
	id nodeText;
	id lastSelectedNode;
	Properties defaultProps;
	float docScale;
	BOOL showMarker;
	id undoManager;
	id findSelectedNode;
	int findPos, findSize;
	BOOL	isOOEServer;
    id		theOOEClient;
    char	*theOOEClientPath;
	id saveToAccessoryWindow;
	id saveToAccessoryControl;
}

- window;
- (Properties *)defaultProps;
- textDidChange:sender;
- window;
- printInfo;
- (BOOL)isEmpty;
- setEmpty:(BOOL)flag;
- (BOOL)hasSavedDocument;
- setSavedDocument:(BOOL)flag;
- (BOOL)needsSaving;
- dirty:(BOOL)flag;
- (int)tag;

@end
