
#import <appkit/appkit.h>
#import "UPath.h"
#import "HitPath.h"
#import "Tree.h"

@interface TreeView:View
{
	UPath *linkPath, *canvasPath;
	HitPath *hitPath;
	id nodeList, agent;
	DrawState drawState;
	BOOL pbConversion;
	Tree *pbTree;
	NXRect canvasRect;
	int xTimes, yTimes;
}

- initFrame:(const NXRect *)frameRect;
- free;
- (BOOL)lockFocus;
- drawSelf:(const NXRect *)r :(int)count;
- drawYourSelf:(const NXRect *)r;
- drawTree:tree inRect:(const NXRect *)r;
- mouseDown:(NXEvent *)event;
- keyDown:(NXEvent *)event;
- (BOOL)checkResize:(const NXRect *)r for:tree;
- setAgent:aAgent;
- agent;
- writePSToStream:(NXStream *)stream usingTree:aTree;
- (BOOL)zoomTo:(float)zoomX :(float)zoomY;
- (BOOL)acceptsFirstResponder;
- (int)canvasX;
- (int)canvasY;
- (BOOL)knowsPagesFirst:(int *)firstPageNum last:(int *)lastPageNum;
- (BOOL)getRect:(NXRect *)theRect forPage:(int)page;

@end

	