/*
		Copyright (c) Uwe Hoffmann, 1995.
                  All Rights Reserved.

Filename: MiscDiagramShape.h
Author:   Uwe Hoffmann
Date:	  Sep 07, 1995

$Id: MiscDiagramShape.h,v 1.0 1995/09/07 11:22:00 Uwe Hoffmann Exp $
 $Log: MiscDiagramShape.h,v $
*/

#import <foundation/NSObject.h>
#import "uwFoundationAdds.h"

@class MiscHitPath, MiscUserPath;

typedef enum {
	MiscCircleShapeType,
	MiscCylinderShapeType,
	MiscDiamondShapeType,
	MiscHexagonShapeType,
	MiscHorizontalArrowShapeType,
	MiscHorizontalTriangleShapeType,
	MiscParallelLinesShapeType,
	MiscParallelogramShapeType,
	MiscRectangleShapeType,
	MiscRoundedRectShapeType,
	MiscVerticalArrowShapeType,
	MiscVerticalTriangleShapeType,
} MiscShapeType;

@interface MiscDiagramShape:NSObject <NSCoding, NSCopying>
{

}

/*"Allocating and initializing"*/
+ newWithZone:(NSZone *)aZone shapeType:(MiscShapeType)aShapeType bounds:(NSRect)aRect;
+ shapeOfType:(MiscShapeType)aShapeType bounds:(NSRect)aRect;

/*"Querying and manipulating shape"*/
- (NSRect)bounds;
- (NSRect)innerBounds;
- (MiscShapeType)shapeType;
- (void)moveTo:(NSPoint)aPos;
- (void)sizeTo:(NSSize)aSize;
- (void)calcIntersection:(NSPoint *)ip angle:(float *)alpha toPoint:(NSPoint)aPoint;
+ (NSSize)calcSizeForInnerSize:(NSSize)aSize shapeType:(MiscShapeType)aShapeType;

/*"Drawing"*/
- (void)drawOutline;
- (void)drawFill;
- (void)drawShadowWithDelta:(NSPoint)aPos;

/*"Hit detection"*/
- (BOOL)hit:(MiscHitPath *)hitPath;

@end
