/*
		Copyright (c) Uwe Hoffmann, 1995.
                  All Rights Reserved.

Filename: MiscDiagramTree.h
Author:   Uwe Hoffmann
Date:	  Jun 30, 1995

$Id: MiscDiagramTree.h,v 1.0 1995/06/30 11:22:00 Uwe Hoffmann Exp $
 $Log: MiscDiagramTree.h,v $
*/

#import "MiscLayoutTree.h"
#import "MiscDiagramShape.h";

@class MiscUserPath;

@interface MiscDiagramTree:MiscLayoutTree
{
@private
	MiscDiagramShape *shape;
    id labelTextCell;
}

/*"Allocating and initializing an MiscDiagramTree instance"*/
+ tree;
+ treeWithLabel:(NSString *)aLabel shapeType:(MiscShapeType)aShapeType;
- initWithLabel:(NSString *)aLabel shapeType:(MiscShapeType)aShapeType;

/*"Drawing"*/
- (void)drawOutline;
- (void)drawFill;
- (void)drawCellsInView:aView attachments:(BOOL)aBool;
- (void)fillLines:(MiscUserPath *)linesPath;

/*"Accessing and manipulating shape"*/
- (MiscShapeType)shapeType;
- (void)setShapeType:(MiscShapeType)aShapeType;

/*"Accessing and manipulating node contents"*/
- (NSString *)label;
- (void)setLabel:(NSString *)aLabel;

@end
