
#import <foundation/NSObject.h>
#import <objc/objc-class.h>

typedef struct {
	float x;
	float y;
} NSPoint;

typedef struct {
	float width;
	float height;
} NSSize;

typedef struct {
	NSPoint origin;
	NSSize size;
} NSRect;

typedef struct {
	int offset;
	int size;
	char *type;
} NSArgumentInfo;
	
@interface NSMethodSignature:NSObject
{
   
}

+ signatureWithObjCTypes:(const char *)types;
- (unsigned int)numberOfArguments;
- (unsigned int)frameLength;
- (NSArgumentInfo)argumentInfoAtIndex:(unsigned int)index;
- (BOOL)isOneway;
- (unsigned int)methodReturnLength;
- (char *)methodReturnType;

@end

@interface NSInvocation:NSObject
{

}

+ (NSInvocation *)invocationWithMethodSignature:(NSMethodSignature *)sig;
- (BOOL)argumentsRetained;
- (void)getArgument:(void *)argumentLocation atIndex:(int)index;
- (void)getReturnValue:(void *)retLoc;
- (NSMethodSignature *)methodSignature;
- (void)retainArguments;
- (SEL)selector;
- (void)setArgument:(void *)argumentLocation atIndex:(int)index;
- (void)setReturnValue:(void *)retLoc;
- (void)setSelector:(SEL)selector; 
- (void)setTarget:(id)target;
- (id)target;
- (void)invoke;
- (void)invokeWithTarget:(id)target;
- initWithMethodSignature:(NSMethodSignature *)sig;

@end

@interface NSSerializer:NSObject
{
}

+ serializePList:aPropertyList;
+ (void)serializePList:aPropertyList intoData:aData;

@end

//NSInvocation *Misc_NS_INVOCATION(Class aClass, SEL instanceMessage)

//#define Misc_NS_INVOCATION(Class aClass, SEL instanceMessage)

//NSInvocation *Misc_NS_MESSAGE(id anObject, SEL instanceMessage);

NSRect NSMakeRect(float x, float y, float width, float height);
NSPoint NSMakePoint(float x, float y);
NSSize NSMakeSize(float width, float height);
BOOL NSIntersectsRect(NSRect a, NSRect b);

#ifndef MAX
#define  MAX(A,B)	((A) > (B) ? (A) : (B))
#endif
#ifndef MIN
#define  MIN(A,B)	((A) < (B) ? (A) : (B))
#endif
