#import <appkit/appkit.h>

@interface CameraController:Object
{
	id	info;

	id	camera;
	id	outputView;
	id	outputImage;
	id	currentImage;
	id	clipView;
	DPSTimedEntry	animateTE;

	id	grabOutputField;
	id	grabOutput;
	id	frameNumber;

	id	onOffButton;
	id	recButton;
	id	autoGrabButton;

	id	speedMatrix;
	id	fpsBaseRateField;
	id	inputMatrix;
	id	grabOriginXField;
	id	grabOriginYField;
	id	grabSizeWidthField;
	id	grabSizeHeightField;
	
	BOOL	_cameraOn;
	int	_frameCount;
	NXRect	_outputRect;
	NXRect	_sourceRect;
	NXRect	_destRect;
	NXSize	_refFrameSize;
}

- init;
- showInfo:sender;

- start:sender;
- stop:sender;
- grab:sender;
- _saveCurrentFrame;
- adjustOutputFile:pathString;
- _startTimer;
- _stopTimer;
- baseFpsRateChanged:sender;

- startGrabbing:sender;
- stopGrabbing:sender;
- (BOOL)isGrabbing;

- adjustSpeed:sender;
- adjustCameraSource:sender;
- adjustGrabRect:sender;
- _adjustGrabRect;
- zoomIn:sender;
- zoomOut:sender;

- openVideoControls:sender;
- changeHue:sender;
- changeBrightness:sender;
- changeSaturation:sender;
- changeGamma:sender;
- changeSharpness:sender;

- windowDidMove:sender;
- windowDidResize:sender;
- _adjustOcularTitle;

@end