/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: CellScrollView.h,v 1.7 1993/05/18 03:54:42 davis Exp $ */

/*
 *  This ScrollView/Matrix combo is based heavily on the NeXTSTEP 
 *  MiniExample CellScrollView by R. Dunbar Poor and Mai Nguyen.
 */

#import <appkit/ScrollView.h>

@class List;

@interface CellScrollView:ScrollView
{
    id		cellMatrix;	/* Underlying Matrix			*/
    id		cellClass;	/* The class object of the cell		*/
    id		cellSizePrototype;
    int		numCols;	/* How many columns			*/
    BOOL	isSubType;
}

- initFrame:(const NXRect *)frameRect;
- initMatrixCellClass:classId cols:(int)anInt; /* Must be called before used */
- free;
- awakeFromNib;

- cellMatrix;
- loadCol:(int)col from:(List *)cellObjects;	/* Reload/redisplay list */

@end
