/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */


static char RCSId[]="$Id: ContourAutoPane.m,v 1.4 1993/05/18 03:54:45 davis Exp $";

#import <appkit/Application.h>
#import <appkit/Form.h>
#import <appkit/FormCell.h>

#import "ContourAutoPane.h"
#import "Status.h"
#import "StatusContour.h"
#import "ContourOptionsPanel.h"


@implementation ContourAutoPane

- init
{
    [super init];

    [NXApp loadNibSection: "ContourAutoPane.nib"
		    owner: self
		withNames: NO
		 fromZone: [self zone]];

    return self;
}


- (BOOL)updateStatus:aStatus doc:aDoc
{
    [super updateStatus:aStatus doc:aDoc];

    if (status)
	[levelsFormCell setIntValue:[status contourLevels]];

    [levelsFormCell setEnabled:[doc isEnabled]];/* doc is ContourOptionsPanel*/

    return NO;
}


- selectControl:sender
{
    [levelsForm selectText:self];
    return self;
}



- setLevels:sender
{
    [status setContourLevels:[sender intValue]];
    [self forceUpdateStatus:status doc:doc];	/* status may reject levels */
    return self;
}



// Shuts up the compiler about unused RCSId
- (const char *) rcsid
{
    return RCSId;
}


@end
