/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: Inspector.h,v 1.8 1993/05/04 16:22:10 davis Exp $ */

#import <objc/Object.h>
#import <objc/hashtable.h>		/* NXAtom */

@class GnuplotPlot, List, Pane, Status;

#define NO_INSPECTOR		0
#define GENERAL_INSPECTOR	1
#define DATA_INSPECTOR		2
#define AXES_INSPECTOR		3
#define THREED_INSPECTOR	4

@interface Inspector:Object
{
    id		window;			/* The multi-inspector panel	*/

    Pane	*noPane;		/* The Panes */
    Pane	*generalPane;
    Pane	*dataPane;
    Pane	*axesPane;
    Pane	*threeDPane;

    Pane	*currentPane;		/* One of the above Panes	*/

    id		buttonMatrix;

    Status	*status;		/* Current status		*/
    GnuplotPlot	*gnuplotPlot;		/* Current plot			*/

    id		plotButton;
}

- init;

- window;			/* Returns the inspector window		*/

/* 
 *  Services.  (These work because we're the delegate of the inspector 
 *  window.)
 */
- validRequestorForSendType:(NXAtom)sendType andReturnType:(NXAtom)returnType;
- (BOOL)writeSelectionToPasteboard:pboard types:(NXAtom *)types;

- update;			/* Update the current pane		*/
- doPlot:sender;		/* Tell GnuplotPlot to replot		*/

- windowDidUpdate:sender;	/* Make interface match current settings*/

- selectPane:(int)aPane;
- showPane:sender;		/* Target/Action			*/


@end
