/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: Pane.h,v 1.7 1993/05/18 03:55:31 davis Exp $ */

#import <objc/Object.h>

@class Status, View;

@interface Pane:Object
{
    id		window;
    View	*view;

    id		stringSet;

    char	*title;
    char	*icon;

    Status	*status;		/* Current status		*/
    id		doc;			/* Current doc			*/
    BOOL	isCurrentPane;

@private
    BOOL	_textChanged;
}

- init;
- free;

- (View *)view;
- (const char *) icon;

- setTitle: (const char *) aString;
- (const char *) title;

- selectControl:sender;
- (BOOL)updateStatus:aStatus doc:aDoc;
- (BOOL)forceUpdateStatus:aStatus doc:aDoc;

- didSwapIn:sender;
- didSwapOut:sender;
- (BOOL)isCurrentPane;


/** Text Delegate Methods **/

- textDidEnd:textObject endChar:(unsigned short)whyEnd;
- (BOOL) textWillChange:textObject;

@end
