/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */

/* $Id: PlotView.h,v 1.5 1993/05/04 16:22:31 davis Exp $ */

#import <appkit/View.h>


@interface PlotView:View
{
    id		image;				/* The cache NXImage	*/
    NXStream	*epsStream;			/* The stream of EPS	*/
    BOOL	tempFileNeedsUpdate;		/* Does temp match stream? */
    float	imageOrigHeight, imageOrigWidth;
    char	*fullPath;			/* Path of the EPS file	*/
}

- initFrame:(const NXRect *) frameRect;
- free;

					/** Overridden from Responder	**/
- (BOOL)acceptsFirstResponder;
- (BOOL)acceptsFirstMouse;
- drawSelf:(NXRect *)r :(int)count;


- mouseDown:(NXEvent *)theEvent;		/** Drag support	**/
- (NXDragOperation)draggingSourceOperationMaskForLocal:(BOOL)flag;
- (BOOL)shouldDelayWindowOrderingForEvent:(NXEvent *)theEvent;


- (float)scale:(float)scaleFactor;


- (BOOL)validateCommand:menuCell;	/** Auto menu update support	**/


- changeFont:sender;				/** Font operations	**/
- copyFont:sender;
- pasteFont:sender;

						/** Services support	**/
- validRequestorForSendType:(NXAtom)sendType andReturnType:(NXAtom)returnType;
- (BOOL) writeSelectionToPasteboard:pboard types:(NXAtom *)types;


- copy:sender;				/** Pasteboard/Stream operations **/
- copyToPasteboard:pboard;
- copyToPasteboard:pboard types:(NXAtom *)typesList;
- copyPSToStream:(NXStream *)stream;
- copyTIFFToStream:(NXStream *)stream;
- newStream:(NXStream *) aStream;


- (BOOL)saveEPSToFile:(const char *)filename;	/** File operations	**/
- (BOOL)saveTIFFToFile:(const char *)filename;


@end
