/*
 *  Copyright (C) 1993  Robert Davis
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of Version 2, or any later version, of 
 *  the GNU General Public License as published by the Free Software 
 *  Foundation.
 */


static char RCSId[]="$Id: TicObject.m,v 1.3 1993/05/04 16:23:09 davis Exp $";


#import "TicObject.h"


@implementation TicObject


/* Overrides SubObjects initFromString: */
- initFromString:(const char *)aString
{
    return nil;
}


- initFromString:(const char *)aString doubleValue:(double)aDouble
{
    [super init];

    [self setStringValue:aString];
    [self setDoubleValue:aDouble];

    return self;
}


- setDoubleValue:(double)aDouble
{
    doubleValue = aDouble;
    return self;
}


- (double)doubleValue
{
    return doubleValue;
}


// Shuts up the compiler about unused RCSId
- (const char *) rcsid
{
    return RCSId;
}


@end
