/* File: MagnifyView.h - View class for 'Magnify'
 *
 * By: Christopher Lane
 * Symbolic Systems Resources Group
 * Knowledge Systems Laboratory
 * Stanford University
 *
 * Date: 7 January 1992
 *
 * Copyright: 1990, 1991 & 1992 by The Leland Stanford Junior University.
 * This program may be distributed without restriction for non-commercial use.
 */
 
#import <cthreads.h>
#import <appkit/appkit.h>

#define NX_NOBUTTONS (0)
#define NX_MAXPLANES (5)

@interface MagnifyView : View
{  
	Window *invisibleWindow;
	View *invisibleView;
	NXPoint mouse;
	NXSize offset;
	NXRect virtualBounds;
	mutex_t lock;
	float scale, grid;
	BOOL frozen, showCursor, showGrid;
	void *data[NX_MAXPLANES];
	int pixelsWide, pixelsHigh, bps, spp, config, mask;
}

+ newFrame:(const NXRect *) frameRect;

- (BOOL) acceptsFirstResponder;
- copy:sender;
- drawSelf:(const NXRect *) rects :(int) rectCount;
- free;
- sizeTo:(NXCoord) newWidth :(NXCoord) newHeight;
- mouseMoved:(NXEvent *) theEvent;

- drawCursor;
- drawGrid;

- updateBitmap:(NXPoint *) point;

- (float) scale;
- setScale:(float) value;
- (float) grid;
- setGrid:(float) value;

- (BOOL) isFrozen;
- toggleFrozen:sender;
- toggleCursor:sender;

- createWindows;

@end
