#import  <objc/Object.h>
#import  <appkit/View.h>
#import  "common.h"

@class NXImage, NXBitmapImageRep, TextField, PrefControl;

@interface ToyView: View
{
	NXImage		*image;
	NXSize		origSize;
	NXSize		curSize;
	float		scaleFactor;
	unsigned char	*rawmap;
	commonInfo	*comInfo;
	NXRect		selectRect;
	TextField	*commText;
	PrefControl	*preference;
}

- initFromFile:(const char *)filename;
- initFromStream:(NXStream *)stream;
- initDataPlanes:(unsigned char **)planes info:(commonInfo *)cinf;
- setCommText: (TextField *)text;
- setPreference: (PrefControl *)pref;
- (NXSize *)originalSize;
- (NXSize *)resize: (float)factor;
- free;
- (NXImage *)image;
- (commonInfo *)commonInfo;
- (float)scaleFactor;
- (NXRect *)selectedRect;

@end


@interface ToyView (EventHandling)
+ cursor;
- (BOOL)acceptsFirstResponder;
- (BOOL)acceptsFirstMouse;
- resetCursorRects;			/* Over Write */

- setDraggedLine: sender;
- clearDraggedLine;
- mouseDown:(NXEvent *)event;		/* Over Write */
- selectAll:sender;			/* Over Write */
- copy:sender;				/* Over Write */
- drawSelf:(NXRect *)r :(int) count;	/* Over Write */

@end

