#import <objc/Object.h>
#import "common.h"

@class NXImage, Window, ToyView;

#define  mini_YET	0
#define  mini_DEMINI	1
#define  mini_MINI	2

@interface ToyWin: Object
{
	id	thiswindow;
	id	scView;
	id	commentText;
	id	controller;
	float	scaleFactor;
	char	*imageFilename;
	id	messagePanel;
	id	messageText;
	id	scalePanel;
	id	scaleText;
	int	miniFlag;
}

- init: sender;
- free;
- (char *)filename;
- (Window *)window;
- toyView;
- reScale: sender;
- fitScale: sender;
- setScale: sender;
- initLocateWindow:(const char *)fileName
	Width:(int)width Height:(int)height Num:(int)num;
- locateWindow: (int)width : (int)height init:(BOOL)is_init num:(int)wnum;

/* delegate methods */
- windowWillMiniaturize:sender toMiniwindow:miniwindow;
- windowDidDeminiaturize:sender;
- windowWillClose:sender;
- windowDidBecomeKey:sender;
- windowDidExpose:sender;
- windowDidMove:sender;

@end


@interface ToyWin (Drawing)

- (int)drawToyWin:(const char *)fileName Type:(int)type Num:(int)num;
- drawView:(unsigned char **)map info:(commonInfo *)cinf;
- (int)drawFromFile:(const char *)fileName or:(NXStream *)stream Num:(int)num;
- makeComment:(commonInfo *)cinf;

@end


@interface ToyWin (ImageSave)

- print: sender;
- saveAsTiff: sender;
- saveAsEPS: sender;
- saveAs: (int)itype;
- (int)getBitmap:(unsigned char **)map info:(commonInfo **)infp;
- freeTempBitmap;
- (char *)getSavename: (const char *)path with:(int)itype;
- (char *)getSaveTiffname: (const char *)path jpeg: (BOOL)flag
	compress: (int *)type by: (float *)factor;

@end
